Codeforces Round #478 (Div. 2)
题目链接:http://codeforces.com/contest/975
In Aramic language words can only represent objects.
Words in Aramic have special properties:
- A word is a root if it does not contain the same letter more than once.
- A root and all its permutations represent the same object.
- The root xx of a word yy is the word that contains all letters that appear in yy in a way that each letter appears once. For example, the root of "aaaa", "aa", "aaa" is "a", the root of "aabb", "bab", "baabb", "ab" is "ab".
- Any word in Aramic represents the same object as its root.
You have an ancient script in Aramic. What is the number of different objects mentioned in the script?
The first line contains one integer nn (1≤n≤1031≤n≤103) — the number of words in the script.
The second line contains nn words s1,s2,…,sns1,s2,…,sn — the script itself. The length of each string does not exceed 103103.
It is guaranteed that all characters of the strings are small latin letters.
Output one integer — the number of different objects mentioned in the given ancient Aramic script.
5
a aa aaa ab abb
2
3
amer arem mrea
1
In the first test, there are two objects mentioned. The roots that represent them are "a","ab".
In the second test, there is only one object, its root is "amer", the other strings are just permutations of "amer".
题意:给你n个字符串,然后把每个字符串中出现的字母取出来(构成的新字符串忽略顺序记为根),问这n个字符串中不同根的个数。
思路:用一个数组a记录每个字符串中出现的字母,然后再把它按照字典序构成一个新的字符串用set来维护,结果就是set所含的元素数。
代码实现如下:
#include <bits/stdc++.h>
using namespace std; int n;
int a[];
string s[], ss[]; int main() {
cin >>n;
for(int i = ; i < n;i++) {
getchar();
cin >>s[i];
ss[i].clear();
memset(a, , sizeof(a));
int len = s[i].size();
for(int j = ; j < len; j++) {
int t = s[i][j] - 'a';
a[t]++;
}
for(int j = ; j < ; j++) {
if(a[j]) ss[i] += (j + 'a');
}
}
set<string> m;
for(int i = ; i < n; i++) {
if(!m.count(ss[i])) {
m.insert(ss[i]);
}
}
cout <<m.size() <<endl;
return ;
}
Mancala is a game famous in the Middle East. It is played on a board that consists of 14 holes.
Initially, each hole has aiai stones. When a player makes a move, he chooses a hole which contains a positive number of stones. He takes all the stones inside it and then redistributes these stones one by one in the next holes in a counter-clockwise direction.
Note that the counter-clockwise order means if the player takes the stones from hole ii, he will put one stone in the (i+1)(i+1)-th hole, then in the (i+2)(i+2)-th, etc. If he puts a stone in the 1414-th hole, the next one will be put in the first hole.
After the move, the player collects all the stones from holes that contain even number of stones. The number of stones collected by player is the score, according to Resli.
Resli is a famous Mancala player. He wants to know the maximum score he can obtain after one move.
The only line contains 14 integers a1,a2,…,a14a1,a2,…,a14 (0≤ai≤1090≤ai≤109) — the number of stones in each hole.
It is guaranteed that for any ii (1≤i≤141≤i≤14) aiai is either zero or odd, and there is at least one stone in the board.
Output one integer, the maximum possible score after one move.
0 1 1 0 0 0 0 0 0 7 0 0 0 0
4
5 1 1 1 1 0 0 0 0 0 0 0 0 0
8
In the first test case the board after the move from the hole with 77 stones will look like 1 2 2 0 0 0 0 0 0 0 1 1 1 1. Then the player collects the even numbers and ends up with a score equal to 44.
题意:给你14个洞,每个洞里面有0个或奇数个石子,然后可以进行一次操作,这题操作就是将一个含非零石子数的洞中的石子全部取出然后按顺序填入后面的洞中(超出14就从第一个洞开始),每次只能放1个。
思路:因为总共就14个洞,所以就暴力即可(坑点:会爆int)~比赛时因为某个地方爆了int没发现和突然zz导致心态爆炸了……
代码实现如下:
#include <bits/stdc++.h>
using namespace std; long long a[], b[]; int main() {
for(int i = ; i <= ; i++) {
cin >> a[i];
}
long long ans = , sum;
for(int i = ; i <= ; i++) {
sum = ;
memset(b, , sizeof(b));
if(a[i] <= )
continue;
for(int j = ; j <= ; j++) {
if(i != j) {
b[j] = a[j];
}
}
int n = a[i] / , m = a[i] % ;
for(int j = ; j <= ; j++) b[j] += n;
for(int j = i + ; j <= && m > ; j++, m--) {
b[j] ++;
}
for(int j = ; m > ; j++, m--) {
b[j] ++;
}
for(int j = ; j <= ; j++) {
if(b[j] % == ) {
sum += b[j];
}
}
ans = max(ans, sum);
}
cout << ans << endl;
return ;
}
Ivar the Boneless is a great leader. He is trying to capture Kattegat from Lagertha. The war has begun and wave after wave Ivar's warriors are falling in battle.
Ivar has nn warriors, he places them on a straight line in front of the main gate, in a way that the ii -th warrior stands right after (i−1)(i−1) -th warrior. The first warrior leads the attack.
Each attacker can take up to aiai arrows before he falls to the ground, where aiai is the ii -th warrior's strength.
Lagertha orders her warriors to shoot kiki arrows during the ii -th minute, the arrows one by one hit the first still standing warrior. After all Ivar's warriors fall and all the currently flying arrows fly by, Thor smashes his hammer and all Ivar's warriors get their previous strengths back and stand up to fight again. In other words, if all warriors die in minute tt , they will all be standing to fight at the end of minute tt .
The battle will last for qq minutes, after each minute you should tell Ivar what is the number of his standing warriors.
The first line contains two integers nn and qq (1≤n,q≤2000001≤n,q≤200000 ) — the number of warriors and the number of minutes in the battle.
The second line contains nn integers a1,a2,…,ana1,a2,…,an (1≤ai≤1091≤ai≤109 ) that represent the warriors' strengths.
The third line contains qq integers k1,k2,…,kqk1,k2,…,kq (1≤ki≤10141≤ki≤1014 ), the ii -th of them represents Lagertha's order at the ii -th minute: kiki arrows will attack the warriors.
Output qq lines, the ii -th of them is the number of standing warriors after the ii -th minute.
5 5
1 2 1 2 1
3 10 1 1 1
3
5
4
4
3
4 4
1 2 3 4
9 1 10 6
1
4
4
1
In the first example:
- after the 1-st minute, the 1-st and 2-nd warriors die.
- after the 2-nd minute all warriors die (and all arrows left over are wasted), then they will be revived thus answer is 5 — all warriors are alive.
- after the 3-rd minute, the 1-st warrior dies.
- after the 4-th minute, the 2-nd warrior takes a hit and his strength decreases by 1.
- after the 5-th minute, the 2-nd warrior dies.
题意:人肉盾请了解一下,第i个人可以抵挡ai只弓箭(看作hp),第i分钟地方射出ki只箭, 战争持续了q分钟。问每分钟还有多少人还活着(注意,当所有人都死亡时,将会集体复活,雾)。
思路:用前缀和记录前i个人的总hp,然后用t来记录前i分钟的弓箭数,当t>=sum[n]时将t设为0,然后进行二分即可。
代码实现如下:
#include <bits/stdc++.h>
using namespace std; const int maxn = 2e5 + ;
int n, q;
long long x;
long long a[maxn], sum[maxn]; int main() {
cin >>n >>q;
sum[] = ;
for(int i= ; i<=n;i++) {
cin >>a[i];
sum[i] = sum[i-] + a[i];
}
long long t = ;
while(q--) {
cin >>x;
t += x;
if(t >= sum[n]) t = ;
int pos = upper_bound(sum,sum + n + , t) - sum - ;
//cout <<pos <<endl <<endl;
cout <<n - pos <<endl;
}
return ;
}
Ghosts live in harmony and peace, they travel the space without any purpose other than scare whoever stands in their way.
There are nn ghosts in the universe, they move in the OXYOXY plane, each one of them has its own velocity that does not change in time: →V=Vx→i+Vy→jV→=Vxi→+Vyj→ where VxVx is its speed on the xx-axis and VyVy is on the yy-axis.
A ghost ii has experience value EXiEXi, which represent how many ghosts tried to scare him in his past. Two ghosts scare each other if they were in the same cartesian point at a moment of time.
As the ghosts move with constant speed, after some moment of time there will be no further scaring (what a relief!) and the experience of ghost kind GX=∑ni=1EXiGX=∑i=1nEXi will never increase.
Tameem is a red giant, he took a picture of the cartesian plane at a certain moment of time TT, and magically all the ghosts were aligned on a line of the form y=a⋅x+by=a⋅x+b. You have to compute what will be the experience index of the ghost kind GXGX in the indefinite future, this is your task for today.
Note that when Tameem took the picture, GXGX may already be greater than 00, because many ghosts may have scared one another at any moment between [−∞,T][−∞,T].
The first line contains three integers nn, aa and bb (1≤n≤2000001≤n≤200000, 1≤|a|≤1091≤|a|≤109, 0≤|b|≤1090≤|b|≤109) — the number of ghosts in the universe and the parameters of the straight line.
Each of the next nn lines contains three integers xixi, VxiVxi, VyiVyi (−109≤xi≤109−109≤xi≤109, −109≤Vxi,Vyi≤109−109≤Vxi,Vyi≤109), where xixi is the current xx-coordinate of the ii-th ghost (and yi=a⋅xi+byi=a⋅xi+b).
It is guaranteed that no two ghosts share the same initial position, in other words, it is guaranteed that for all (i,j)(i,j) xi≠xjxi≠xj for i≠ji≠j.
Output one line: experience index of the ghost kind GXGX in the indefinite future.
4 1 1
1 -1 -1
2 1 1
3 1 1
4 -1 -1
8
3 1 0
-1 1 0
0 0 -1
1 -1 -2
6
3 1 0
0 0 0
1 0 0
2 0 0
0
There are four collisions (1,2,T−0.5)(1,2,T−0.5), (1,3,T−1)(1,3,T−1), (2,4,T+1)(2,4,T+1), (3,4,T+0.5)(3,4,T+0.5), where (u,v,t)(u,v,t) means a collision happened between ghosts uu and vv at moment tt. At each collision, each ghost gained one experience point, this means that GX=4⋅2=8GX=4⋅2=8.
In the second test, all points will collide when t=T+1t=T+1.
The red arrow represents the 1-st ghost velocity, orange represents the 2-nd ghost velocity, and blue represents the 3-rd ghost velocity.
题意:n只鬼当在同一时刻同一坐标遇见时会被对方吓到,问在时间为负无穷到正无穷范围(一开始没读清楚,到比赛结束第二题晚上才读清楚,可能是因为比赛结束后补D已经到一点头脑不清醒的缘故吧)内所有鬼被吓到次数的和。神奇的是,在T时刻,所有的鬼都在直线y=ax+b上,给你鬼在T时刻的横坐标和鬼的在xy轴的速度。
思路:本题求的其实就是鬼的行进路线所在直线间的交点数*2,易知两条直线在同一平面内只有平行和相交,由题意所说的T时刻所有的鬼在同一直线上知,鬼的行进路线如果平行只能是同时沿着T时刻的那条直线运动;而不平行的肯定会相交啦~我们先将题目中给的信息进行化简,如下图(字丑见谅):
#include <map>
#include <cstdio>
#include <cstdlib>
using namespace std; const int maxn = 2e5 + ;
typedef long long ll;
int n, a, b;
ll x[maxn], y[maxn];
map<ll,ll> mp1;
map<pair<ll, ll>, ll> mp2; int main() {
scanf("%d%d%d", &n, &a, &b);
for(int i = ; i < n; i++) {
scanf("%*s%I64d%I64d", &x[i], &y[i]);
mp1[a * x[i] - y[i]]++;
mp2[make_pair(x[i], y[i])]++;
}
ll ans = ;
for(int i = ; i < n; i++) {
ans += mp1[a * x[i] - y[i]] - mp2[make_pair(x[i], y[i])];
}
printf("%I64d\n", ans);
return ;
}
Codeforces Round #478 (Div. 2)的更多相关文章
- 【map离散&容斥】Ghosts @Codeforces Round #478 (Div. 2) D
传送门 题意:给你一条直线的斜率a和截距b,和某一时刻n个在直线上的点的横坐标,以及沿坐标轴方向的速度.问你这些点在(-∞,+∞)的时间内的碰撞次数. solution 设两个点在t时刻相碰,有: x ...
- 【推导】Codeforces Round #478 (Div. 2) D. Ghosts
题意:给你一条直线以及初始时刻这条直线上的一些人的坐标,以及他们的速度矢量.让你对每个人计算他在过去无限远到将来无限远的时间内会与多少人处于同一个点,然后对每个人的这个值求和. 列方程组:两个人i,j ...
- Codeforces Round #478 (Div. 2) ABCDE
A. Aramic script time limit per test 1 second memory limit per test 256 megabytes input standard inp ...
- B. Mancala (Codeforces Round #478 (Div. 2))
#include <bits/stdc++.h> using namespace std; ; typedef long long ll; ll a[maxn]; ll b[maxn]; ...
- Codeforces Round #366 (Div. 2) ABC
Codeforces Round #366 (Div. 2) A I hate that I love that I hate it水题 #I hate that I love that I hate ...
- Codeforces Round #354 (Div. 2) ABCD
Codeforces Round #354 (Div. 2) Problems # Name A Nicholas and Permutation standard input/out ...
- Codeforces Round #368 (Div. 2)
直达–>Codeforces Round #368 (Div. 2) A Brain’s Photos 给你一个NxM的矩阵,一个字母代表一种颜色,如果有”C”,”M”,”Y”三种中任意一种就输 ...
- cf之路,1,Codeforces Round #345 (Div. 2)
cf之路,1,Codeforces Round #345 (Div. 2) ps:昨天第一次参加cf比赛,比赛之前为了熟悉下cf比赛题目的难度.所以做了round#345连试试水的深浅..... ...
- Codeforces Round #279 (Div. 2) ABCDE
Codeforces Round #279 (Div. 2) 做得我都变绿了! Problems # Name A Team Olympiad standard input/outpu ...
随机推荐
- Swift-可选值(Optional)讲解
前提:Swift中有规定:对象中的任何属性在创建时,都必须要有明确的初始化值 1.定义可选类型 方式一:常规方式(不常用) var name : Optional<String> = ni ...
- jconsole工具监控java运行情况
jconsole是jdk自带的工具.所以要先安装jdk 1.jconsole工具的路径: 通过which jconsole来查看 /usr/local/jdk1.7.0_79/bin/jconsol ...
- mysql 重置 root 密码
mysqld_safe --skip-grant-tables & UPDATE mysql.user SET authentication_string=PASSWORD('mima') W ...
- [C/C++] 友元函数和友元类
A---友元函数: class Data{ public: ... friend int f(int &m);//友元函数 ... } 友元函数是可以直接访问类的私有成员的非成员函数.它是定义 ...
- poj3074-Sodoku
解数独. 分析 考虑如何把数独解合法的条件转化为经典的01精确覆盖: 每个格子只能填一个数,1-9 每一列刚好填了1-9 每一行刚好填了1-9 每个九宫格刚好填了1-9 也就是说,每个格子,列,行,九 ...
- BZOJ4735 你的生命已如风中残烛(组合数学)
将每个位置上的数都-1,则显然相当于前缀和始终非负. 然后就是完全想不到的了.考虑往里面加一张-1的牌.假设在一个合法排列的最后添上一个-1,那么在该排列的所有循环同构排列中,满足前m个前缀和都非负的 ...
- Urllib--爬虫
1.简单爬虫 from urllib import request def f(url): print('GET: %s' % url) resp = request.urlopen(url) #赋给 ...
- Socket网络编程实例1
Socket: 对所有上层协议(TCP/IP,UDP等)的底层封装. 网络上的两个程序通过一个双向的通信连接实现数据的交换,这个连接的一端称为一个socket. 建立网络通信连接至少要一对端口号(so ...
- springboot2.0 集成elasticsearch,实现检索、分页、排序
springboot整合es的方式: transport方式(7.0弃用,8.0移除) spring-data(完全当做数据库来用,无法全部支持es,内部也是基于transport,包装后使用非常简单 ...
- BZOJ1856:[SCOI2010]字符串——题解
https://www.lydsy.com/JudgeOnline/problem.php?id=1856 lxhgww最近接到了一个生成字符串的任务,任务需要他把n个1和m个0组成字符串,但是任务还 ...